#define _GNU_SOURCE

#include <errno.h>
#include <string.h>
#include <strings.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/poll.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <stdio.h>
#include <fcntl.h>
#include <netinet/in.h>
#include <sys/time.h>
#include <sys/ioctl.h>
#include <time.h>
#include <arpa/inet.h>
#include <stdarg.h>

#include <Conn.h>

/* Global variables */
static unsigned short	debug = 1;


static void trigger(struct Conn *C)
{
	printf("Trigger is running on %llu!\n", Conn_getid(C));
}

int main(void)
{
	char *stat;
	int ret;
	struct Conn *C;

	Conn_debug(NULL, debug);

	ret = Conn_init(0);
	if (ret == -1) {
		printf("%s", Conn_strerror());
		return 1;
	}

	/* Listen to a port */
	C = Conn_socket(PF_INET, SOCK_STREAM, 60000);
	if (C == NULL) {
		printf("Error creating socket [%s]!\n",
			Conn_strerror());
		return 1;
	}

	/* Install connection specific trigger */
	Conn_set_cb(C, CONN_CB_TRIGGER, trigger);

	/* Force a timeout for connect (in seconds) */
	Conn_set(C, CONN_PARA_TRIGGER, 3);

	while (1) {
		ret = Conn_poll(1000);
		if (ret == -1) {
			printf("Error in poll [%s]!\n",
				Conn_strerror());
			break;
		}

		if (ret == 0) {
			printf("Finish work!\n");
			break;
		}

		if (debug >= 9) {
			stat = Conn_status(0);
			printf("%s\n", stat);
			free(stat);
		}
	}

	return 0;
}
